library customer;
import 'model.dart';
import 'package:angular2/common.dart';
import 'package:fo_components/fo_components.dart';


class Customer extends Model
{
  Customer()
  {

  }

  Customer.parse(Map<String, dynamic> data) : super.parse(data)
  {
    id = data["id"];
    email = data["email"];
    emailShop = data["email_shop"];
    phone = data["phone"];
    socialNumber = data["social_number"];
    firstname = data["firstname"];
    lastname = data["lastname"];
    preferredLanguage = data["preferred_language"];
    street = data["street"];
    postalCode = data["postal_code"];
    city = data["city"];
  }

  @override
  Map<String, dynamic> get properties
  {
    Map<String, dynamic> data = new Map();
    data["email"] = email;
    data["email_shop"] = emailShop;
    data["phone"] = phone;
    data["social_number"] = socialNumber;
    data["firstname"] = firstname;
    data["lastname"] = lastname;
    data["preferred_language"] = preferredLanguage;
    data["street"] = street;
    data["postal_code"] = postalCode;
    data["city"] = city;
    return data;
  }

  @override
  List<String> get uniqueFields => ["email", "email_shop", "phone", "social_number"];

  String email;
  String emailShop;
  String phone;
  String socialNumber;
  String firstname;
  String lastname;
  String preferredLanguage = "sv";
  String street;
  String postalCode;
  String city;

  static Map<String, dynamic> get controlsConfig => _controlsConfig;

  static Map<String, dynamic> _controlsConfig =
  {
    "email":[null, Validators.compose([Validators.required, Validators.maxLength(100)])],
    "phone":[null, Validators.compose([Validators.required, FoValidators.isPhoneNumber, Validators.maxLength(32)])],
    "social_number":[null, Validators.compose([Validators.required, Validators.minLength(12), Validators.maxLength(12), FoValidators.isNumeric])],
    "firstname":[null, Validators.compose([Validators.required, FoValidators.isAlpha, Validators.maxLength(64)])],
    "lastname":[null, Validators.compose([Validators.required, FoValidators.isAlpha, Validators.maxLength(64)])],
    "street":[null, Validators.compose([Validators.required, Validators.minLength(4), Validators.maxLength(64)])],
    "postal_code":[null, Validators.compose([Validators.required, FoValidators.isAlphaNumeric, Validators.minLength(2), Validators.maxLength(20)])],
    "city":[null, Validators.compose([Validators.required, Validators.maxLength(64)])]
  };
}