library service;

import 'model.dart';
import 'service_addon.dart';

class Service extends Model
{
  Service()
  {

  }

  Service.parse(Map<String, dynamic> data) : super.parse(data)
  {
    id = data["id"];
    category = data["category"];
    description = data["description"];
    name = data["name"];
    _durationMinutes = data["duration"];
    _price = data["price"];
    for (Map<String, dynamic> addon in data["addons"])
    {
      _addons.add(new ServiceAddon.parse(addon));
    }
  }

  Service.from(Service other)
  {
    id = other.id;
    category = other.category;
    description = other.description;
    name = other.name;
    _durationMinutes = other._durationMinutes;
    _price = other.price;
    _addons = new List.from(other._addons);
  }

  @override
  Map<String, dynamic> get properties
  {
    Map<String, dynamic> data;
    data["category"] = category;
    data["description"] = description;
    data["name"] = name;
    data["duration"] = _durationMinutes;
    data["price"] = _price;
    data["addons"] = new List<Map<String, dynamic>>();
    for (ServiceAddon addon in _addons)
    {
      data["addons"].add(addon.properties);
    }
    return data;
  }

  List<ServiceAddon> get addons => _addons;
  int get durationMinutes => _durationMinutes;
  double get price => _price;

  @override
  List<String> get uniqueFields => [];

  List<ServiceAddon> _addons = new List();
  String category;
  String description;
  String name;
  int _durationMinutes;
  double _price;
}